diff --git a/gdb/arc-tdep.c b/gdb/arc-tdep.c
index 3d4f6ec2cd51..9c03bed80e0e 100644
--- a/gdb/arc-tdep.c
+++ b/gdb/arc-tdep.c
@@ -208,7 +208,7 @@ arc_insn_get_operand_value_signed (const struct arc_instruction &insn,
 
 /* Get register with base address of memory operation.  */
 
-int
+static int
 arc_insn_get_memory_base_reg (const struct arc_instruction &insn)
 {
   /* POP_S and PUSH_S have SP as an implicit argument in a disassembler.  */
@@ -227,7 +227,7 @@ arc_insn_get_memory_base_reg (const struct arc_instruction &insn)
 
 /* Get offset of a memory operation INSN.  */
 
-CORE_ADDR
+static CORE_ADDR
 arc_insn_get_memory_offset (const struct arc_instruction &insn)
 {
   /* POP_S and PUSH_S have offset as an implicit argument in a
@@ -334,7 +334,7 @@ arc_insn_get_branch_target (const struct arc_instruction &insn)
 
 /* Dump INSN into gdb_stdlog.  */
 
-void
+static void
 arc_insn_dump (const struct arc_instruction &insn)
 {
   struct gdbarch *gdbarch = target_gdbarch ();
diff --git a/gdb/cp-support.c b/gdb/cp-support.c
index 16a9a40fa658..a29e69370801 100644
--- a/gdb/cp-support.c
+++ b/gdb/cp-support.c
@@ -1810,7 +1810,7 @@ cp_get_symbol_name_matcher (const lookup_name_info &lookup_name)
 
 namespace selftests {
 
-void
+static void
 test_cp_symbol_name_matches ()
 {
 #define CHECK_MATCH(SYMBOL, INPUT)					\
diff --git a/gdb/csky-linux-tdep.c b/gdb/csky-linux-tdep.c
index 46af0aba5014..bda527af1dd2 100644
--- a/gdb/csky-linux-tdep.c
+++ b/gdb/csky-linux-tdep.c
@@ -106,7 +106,7 @@ csky_collect_gregset (const struct regset *regset,
 
 /* Implement the supply_regset hook for FP registers in core files.  */
 
-void
+static void
 csky_supply_fregset (const struct regset *regset,
 		     struct regcache *regcache, int regnum,
 		     const void *regs, size_t len)
diff --git a/gdb/dictionary.c b/gdb/dictionary.c
index e47e0217b9cd..939f32b59afb 100644
--- a/gdb/dictionary.c
+++ b/gdb/dictionary.c
@@ -465,7 +465,7 @@ dict_add_pending (struct dictionary *dict,
 /* Initialize ITERATOR to point at the first symbol in DICT, and
    return that first symbol, or NULL if DICT is empty.  */
 
-struct symbol *
+static struct symbol *
 dict_iterator_first (const struct dictionary *dict,
 		     struct dict_iterator *iterator)
 {
@@ -475,14 +475,14 @@ dict_iterator_first (const struct dictionary *dict,
 /* Advance ITERATOR, and return the next symbol, or NULL if there are
    no more symbols.  */
 
-struct symbol *
+static struct symbol *
 dict_iterator_next (struct dict_iterator *iterator)
 {
   return (DICT_VECTOR (DICT_ITERATOR_DICT (iterator)))
     ->iterator_next (iterator);
 }
 
-struct symbol *
+static struct symbol *
 dict_iter_match_first (const struct dictionary *dict,
 		       const lookup_name_info &name,
 		       struct dict_iterator *iterator)
@@ -490,7 +490,7 @@ dict_iter_match_first (const struct dictionary *dict,
   return (DICT_VECTOR (dict))->iter_match_first (dict, name, iterator);
 }
 
-struct symbol *
+static struct symbol *
 dict_iter_match_next (const lookup_name_info &name,
 		      struct dict_iterator *iterator)
 {
diff --git a/gdb/f-lang.c b/gdb/f-lang.c
index edff446ed85c..2ae1e8eaba4e 100644
--- a/gdb/f-lang.c
+++ b/gdb/f-lang.c
@@ -243,7 +243,8 @@ f_collect_symbol_completion_matches (completion_tracker &tracker,
 }
 
 /* Special expression evaluation cases for Fortran.  */
-struct value *
+
+static struct value *
 evaluate_subexp_f (struct type *expect_type, struct expression *exp,
 		   int *pos, enum noside noside)
 {
diff --git a/gdb/hppa-tdep.c b/gdb/hppa-tdep.c
index e89f9abe6c2e..133e8fe8f4b9 100644
--- a/gdb/hppa-tdep.c
+++ b/gdb/hppa-tdep.c
@@ -1296,7 +1296,7 @@ hppa64_frame_align (struct gdbarch *gdbarch, CORE_ADDR addr)
   return align_up (addr, 16);
 }
 
-CORE_ADDR
+static CORE_ADDR
 hppa_read_pc (readable_regcache *regcache)
 {
   ULONGEST ipsw;
diff --git a/gdb/i386-tdep.c b/gdb/i386-tdep.c
index 6633babf9640..e620dd5b85df 100644
--- a/gdb/i386-tdep.c
+++ b/gdb/i386-tdep.c
@@ -8177,7 +8177,7 @@ i386_fast_tracepoint_valid_at (struct gdbarch *gdbarch, CORE_ADDR addr,
    length LEN in bits.  If non-NULL, NAME is the name of its type.
    If no suitable type is found, return NULL.  */
 
-const struct floatformat **
+static const struct floatformat **
 i386_floatformat_for_type (struct gdbarch *gdbarch,
 			   const char *name, int len)
 {
diff --git a/gdb/parse.c b/gdb/parse.c
index 6f52dfb7762c..5ae9753f2642 100644
--- a/gdb/parse.c
+++ b/gdb/parse.c
@@ -181,7 +181,7 @@ write_exp_elt_sym (struct expr_builder *ps, struct symbol *expelt)
   write_exp_elt (ps, &tmp);
 }
 
-void
+static void
 write_exp_elt_msym (struct expr_builder *ps, minimal_symbol *expelt)
 {
   union exp_element tmp;
diff --git a/gdb/ppc-linux-tdep.c b/gdb/ppc-linux-tdep.c
index 9e6bae1a3828..775ffab0f633 100644
--- a/gdb/ppc-linux-tdep.c
+++ b/gdb/ppc-linux-tdep.c
@@ -1961,7 +1961,7 @@ ppc_init_linux_record_tdep (struct linux_record_tdep *record_tdep,
    length LEN in bits.  If non-NULL, NAME is the name of its type.
    If no suitable type is found, return NULL.  */
 
-const struct floatformat **
+static const struct floatformat **
 ppc_floatformat_for_type (struct gdbarch *gdbarch,
                           const char *name, int len)
 {
diff --git a/gdb/remote.c b/gdb/remote.c
index a39eb515a471..306edcfd5ace 100644
--- a/gdb/remote.c
+++ b/gdb/remote.c
@@ -5044,7 +5044,7 @@ remote_target::remote_packet_size (const protocol_feature *feature,
   rs->explicit_packet_size = packet_size;
 }
 
-void
+static void
 remote_packet_size (remote_target *remote, const protocol_feature *feature,
 		    enum packet_support support, const char *value)
 {
@@ -6814,7 +6814,7 @@ remote_target::stop_reply_queue_length ()
   return rs->stop_reply_queue.size ();
 }
 
-void
+static void
 remote_notif_stop_parse (remote_target *remote,
 			 struct notif_client *self, const char *buf,
 			 struct notif_event *event)
diff --git a/gdb/rs6000-aix-tdep.c b/gdb/rs6000-aix-tdep.c
index f0a9ca498d15..5021916baf7a 100644
--- a/gdb/rs6000-aix-tdep.c
+++ b/gdb/rs6000-aix-tdep.c
@@ -141,7 +141,7 @@ aix_sighandle_frame_prev_register (struct frame_info *this_frame,
   return trad_frame_get_register (this_trad_cache, this_frame, regnum);
 }
 
-int
+static int
 aix_sighandle_frame_sniffer (const struct frame_unwind *self,
 			     struct frame_info *this_frame,
 			     void **this_prologue_cache)
diff --git a/gdb/s12z-tdep.c b/gdb/s12z-tdep.c
index 02b3140bf27d..72cc1777c8a9 100644
--- a/gdb/s12z-tdep.c
+++ b/gdb/s12z-tdep.c
@@ -147,7 +147,7 @@ s12z_fprintf_disasm (void *stream, const char *format, ...)
   return 0;
 }
 
-struct disassemble_info
+static struct disassemble_info
 s12z_disassemble_info (struct gdbarch *gdbarch)
 {
   struct disassemble_info di;
diff --git a/gdb/source.c b/gdb/source.c
index 898a3cec1e32..6fc4f59fa54c 100644
--- a/gdb/source.c
+++ b/gdb/source.c
@@ -679,7 +679,7 @@ info_source_command (const char *ignore, int from_tty)
    letters (for dos) as well as leading '/' characters and './'
    sequences.  */
 
-const char *
+static const char *
 prepare_path_for_appending (const char *path)
 {
   /* For dos paths, d:/foo -> /foo, and d:foo -> foo.  */
diff --git a/gdb/sparc64-linux-tdep.c b/gdb/sparc64-linux-tdep.c
index ea5773042317..62713926a26e 100644
--- a/gdb/sparc64-linux-tdep.c
+++ b/gdb/sparc64-linux-tdep.c
@@ -120,7 +120,7 @@ sparc64_linux_sigframe_init (const struct tramp_frame *self,
    gdbarch hook.
    Displays information related to ADI memory corruptions.  */
 
-void
+static void
 sparc64_linux_handle_segmentation_fault (struct gdbarch *gdbarch,
 				      struct ui_out *uiout)
 {
diff --git a/gdb/stack.c b/gdb/stack.c
index c5008b855aeb..47d9e3359ad7 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -1432,7 +1432,7 @@ print_frame (const frame_print_options &fp_opts,
 /* Completion function for "frame function", "info frame function", and
    "select-frame function" commands.  */
 
-void
+static void
 frame_selection_by_function_completer (struct cmd_list_element *ignore,
 				       completion_tracker &tracker,
 				       const char *text, const char *word)